diff --git a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
index f0c84768c..edf66c196 100644
--- a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
+++ b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
@@ -5,19 +5,26 @@ import static org.lwjgl.glfw.GLFW.*;
 
 import java.awt.*;
 import java.awt.image.BufferedImage;
+import java.io.IOException;
+import java.io.InputStream;
 import java.lang.reflect.InvocationTargetException;
 import java.lang.reflect.Method;
 import java.nio.ByteBuffer;
 import java.util.HashMap;
 import java.util.Map;
+import java.nio.IntBuffer;
+import java.util.Objects;
 
 import javax.imageio.ImageIO;
 import javax.swing.JFrame;
 
 import com.mojang.logging.CategorizedLogger;
 import com.mojang.logging.LogUtils;
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
 import net.minecraft.core.util.helper.Color;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.BufferUtils;
 import org.lwjgl.PointerBuffer;
 import org.lwjgl.glfw.GLFW;
 import org.lwjgl.glfw.GLFWImage;
@@ -35,6 +42,8 @@ import com.github.zarzelcow.legacylwjgl3.implementation.input.InputImplementatio
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.PanelCrashReport;
 import net.minecraft.core.UnexpectedThrowable;
+import org.lwjgl.stb.STBImage;
+import org.slf4j.Logger;
 
 public class GameWindowGLFW implements GameWindow {
     public static final CategorizedLogger LOGGER = LogUtils.getLogger();
@@ -122,7 +131,7 @@ public class GameWindowGLFW implements GameWindow {
                 int res = resolutions[i];
                 ByteBuffer icon = getImageBuffer("/icon/" + res + ".png");
                 if (icon == null) {
-                    LOGGER.error("Icon at resolution '" + res + "' is null! Skipping icons!");
+                    LOGGER.error("Icon at resolution '{}' is null! Skipping icons!", res);
                     gb.close();
                     break iconLabel;
                 }
@@ -410,33 +419,36 @@ public class GameWindowGLFW implements GameWindow {
         }
     }
 
+    private static ByteBuffer buffer = BufferUtils.createByteBuffer(1024 * 1024);
     /**
      * Reads the specified image resource and returns the raw data as a ByteBuffer.
      *
      * @param resource the resource to read
      * @return the resource data
      */
-    public static ByteBuffer getImageBuffer(String resource) {
-        try {
-            BufferedImage image = ImageIO.read(GameWindowGLFW.class.getResourceAsStream(resource));
-            ByteBuffer buf = createByteBuffer(image.getWidth() * image.getHeight() * 4);
-            // Manually filling out the damn buffer since I can't find any utility that actually does it properly
-            // I don't understand why icon loading for LWJGL3 is such a pain in the ass too
-            int index = 0;
-            for (int y = 0; y < image.getHeight(); y++) {
-                for (int x = 0; x < image.getWidth(); x++) {
-                    int color = image.getRGB(x, y);
-                    buf.put(index + 0, (byte) Color.redFromInt(color)); // Red
-                    buf.put(index + 1, (byte) Color.greenFromInt(color)); // Green
-                    buf.put(index + 2, (byte) Color.blueFromInt(color)); // Blue
-                    buf.put(index + 3, (byte) Color.alphaFromInt(color)); // Alpha
-                    index += 4;
+    public static @Nullable ByteBuffer getImageBuffer(final String resource) {
+        try(final InputStream stream = GameWindowGLFW.class.getResourceAsStream(resource)) {
+            if (stream == null) {
+                LOGGER.error("No icon could be found at '{}'!", resource);
+                return null;
+            }
+            buffer.clear();
+            int value;
+            while ((value = stream.read()) != -1) {
+                if (buffer.remaining() < 1) {
+                    final ByteBuffer newBuf = BufferUtils.createByteBuffer(buffer.capacity() * 2);
+                    newBuf.put(buffer);
+                    buffer = newBuf;
                 }
+                buffer.put((byte) value);
             }
-            buf.flip();
-            return buf;
-        } catch (Exception e) {
-            LOGGER.warn("Couldn't open icon image.", e);
+            final IntBuffer x = BufferUtils.createIntBuffer(1);
+            final IntBuffer y = BufferUtils.createIntBuffer(1);
+            final IntBuffer comp = BufferUtils.createIntBuffer(1);
+            return (ByteBuffer) Objects.requireNonNull((ByteBuffer) STBImage.stbi_load_from_memory((ByteBuffer) (buffer.flip()), x, y, comp, STBImage.STBI_rgb_alpha),
+                STBImage::stbi_failure_reason);
+        } catch (final Exception e) {
+            LOGGER.error("Couldn't open icon image...", e);
             return null;
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
index 211de19b9..8f93b4bd1 100644
--- a/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
+++ b/game/client/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
@@ -17,7 +17,7 @@ import java.util.Arrays;
 public class ChunkProviderStatic
     implements IChunkProvider
 {
-    public static final int CHUNK_RADIUS = 64; // Radius should *always* be a power of 2!
+    public static final int CHUNK_RADIUS = 32; // Radius should *always* be a power of 2!
     public static final int CHUNK_MASK = CHUNK_RADIUS * 2 - 1;
 
     private static final Logger LOGGER = LogUtils.getLogger();
diff --git a/game/core/build.gradle.kts b/game/core/build.gradle.kts
index c084dc811..90b5c0cbd 100644
--- a/game/core/build.gradle.kts
+++ b/game/core/build.gradle.kts
@@ -21,15 +21,7 @@ run {
 repositories {
     mavenCentral()
     maven("https://libraries.minecraft.net/")
-
-    ivy {
-        url = uri("https://github.com/Better-than-Adventure")
-        patternLayout {
-            artifact("[organisation]/releases/download/[revision]/brigadier-[revision].jar")
-            m2Compatible
-        }
-        metadataSources { artifact() }
-    }
+    maven("https://jitpack.io")
 }
 
 dependencies {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java
index a1869363a..59f78ec80 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java
@@ -36,8 +36,7 @@ public class BlockLogicGrass extends BlockLogic
                 int x1 = (x + rand.nextInt(3)) - 1;
                 int y1 = (y + rand.nextInt(5)) - 3;
                 int z1 = (z + rand.nextInt(3)) - 1;
-                int above = world.getBlockId(x1, y1 + 1, z1);
-                if (world.getBlockId(x1, y1, z1) == dirt.id() && world.getBlockLightValue(x1, y1 + 1, z1) >= 4 && Blocks.lightBlock[above] <= 2) {
+                if (world.getBlockId(x1, y1, z1) == dirt.id() && world.getBlockLightValue(x1, y1 + 1, z1) >= 4 && Blocks.lightBlock[world.getBlockId(x1, y1 + 1, z1)] <= 2) {
                     world.setBlockWithNotify(x1, y1, z1, block.id());
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
index a916e98f7..b91269fb9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
@@ -1,9 +1,12 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
@@ -21,12 +24,12 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
 
     @Override
     public void onBlockPlacedByWorld(World world, int x, int y, int z) {
-        if (isInverted) {
-            if (isActive && (world.hasDirectSignal(x, y, z) || world.hasNeighborSignal(x, y, z))) {
+        if (this.isInverted) {
+            if (this.isActive && (world.hasDirectSignal(x, y, z) || world.hasNeighborSignal(x, y, z))) {
                 world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_INVERTED_IDLE.id(), world.getBlockMetadata(x, y, z));
             }
         } else {
-            if (isActive && !(world.hasDirectSignal(x, y, z) || world.hasNeighborSignal(x, y, z))) {
+            if (this.isActive && !(world.hasDirectSignal(x, y, z) || world.hasNeighborSignal(x, y, z))) {
                 world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id(), world.getBlockMetadata(x, y, z));
             }
         }
@@ -40,16 +43,16 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
 
         final boolean hasSignal = world.hasDirectSignal(x, y, z) || world.hasNeighborSignal(x, y, z);
 
-        if (isInverted) {
-            if (hasSignal && isActive) {
+        if (this.isInverted) {
+            if (hasSignal && this.isActive) {
                 world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_INVERTED_IDLE.id(), world.getBlockMetadata(x, y, z));
-            } else if (!hasSignal && !isActive) {
+            } else if (!hasSignal && !this.isActive) {
                 world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_INVERTED_ACTIVE.id(), world.getBlockMetadata(x, y, z));
             }
         } else {
-            if (hasSignal && !isActive) {
+            if (hasSignal && !this.isActive) {
                 world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_ACTIVE.id(), world.getBlockMetadata(x, y, z));
-            } else if (!hasSignal && isActive) {
+            } else if (!hasSignal && this.isActive) {
                 world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id(), world.getBlockMetadata(x, y, z));
             }
         }
@@ -59,28 +62,60 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
     public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
         final boolean hasSignal = world.hasDirectSignal(x, y, z) || world.hasNeighborSignal(x, y, z);
 
-        if (isInverted) {
-            if (hasSignal && isActive) {
+        if (this.isInverted) {
+            if (hasSignal && this.isActive) {
                 world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_INVERTED_IDLE.id(), world.getBlockMetadata(x, y, z));
-            } else if (!hasSignal && !isActive) {
+            } else if (!hasSignal && !this.isActive) {
                 world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_INVERTED_ACTIVE.id(), world.getBlockMetadata(x, y, z));
             }
         } else {
-            if (hasSignal && !isActive) {
+            if (hasSignal && !this.isActive) {
                 world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_ACTIVE.id(), world.getBlockMetadata(x, y, z));
-            } else if (!hasSignal && isActive) {
+            } else if (!hasSignal && this.isActive) {
                 world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id(), world.getBlockMetadata(x, y, z));
             }
         }
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity) {
-        if (isInverted) {
-            return new ItemStack[] { new ItemStack(Blocks.LAMP_INVERTED_ACTIVE, 1, meta) };
+    public boolean onBlockRightClicked(final World world, final int x, final int y, final int z, final Player player, final Side side, final double xHit, final double yHit) {
+        if (this.isInverted) {
+            if (this.isActive) {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id(), world.getBlockMetadata(x, y, z));
+            } else {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_ACTIVE.id(), world.getBlockMetadata(x, y, z));
+            }
         } else {
-            return new ItemStack[] { new ItemStack(Blocks.LAMP_IDLE, 1, meta) };
+            if (this.isActive) {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_INVERTED_IDLE.id(), world.getBlockMetadata(x, y, z));
+            } else {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_INVERTED_ACTIVE.id(), world.getBlockMetadata(x, y, z));
+            }
         }
+
+        return true;
+    }
+
+    @Override
+    public void onActivatorInteract(final World world, final int x, final int y, final int z, final TileEntityActivator activator, final Direction direction) {
+        if (this.isInverted) {
+            if (this.isActive) {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id(), world.getBlockMetadata(x, y, z));
+            } else {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_ACTIVE.id(), world.getBlockMetadata(x, y, z));
+            }
+        } else {
+            if (this.isActive) {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_INVERTED_IDLE.id(), world.getBlockMetadata(x, y, z));
+            } else {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_INVERTED_ACTIVE.id(), world.getBlockMetadata(x, y, z));
+            }
+        }
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity) {
+        return new ItemStack[] { new ItemStack(Blocks.LAMP_IDLE, 1, meta) };
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSignPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSignPainted.java
index 7860a4b14..7c9562c06 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSignPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSignPainted.java
@@ -1,5 +1,9 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
 
@@ -33,4 +37,9 @@ public class BlockLogicSignPainted extends BlockLogicSign implements IPainted{
     public void setColor(World world, int x, int y, int z, DyeColor color) {
         world.setBlockMetadataWithNotify(x, y, z, color.blockMeta << 4 | stripColorFromMetadata(world.getBlockMetadata(x, y, z)));
     }
+
+    @Override
+    public ItemStack[] getBreakResult(final World world, final EnumDropCause dropCause, final int meta, final TileEntity tileEntity) {
+        return new ItemStack[] {new ItemStack(Items.SIGN_PAINTED, 1, fromMetadata(meta).itemMeta)};
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index 6007f9098..d3b4d5984 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -1083,7 +1083,7 @@ public final class Blocks {
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
     public static final Block<BlockLogicSlab> SLAB_COBBLE_NETHERRACK = register("slab.cobble.netherrack", "minecraft:block/slab_cobble_netherrack", 806, (BlockLogicSupplier<BlockLogicSlab>)b -> new BlockLogicSlab(b, Blocks.COBBLE_NETHERRACK))
         .withSound(BlockSounds.STONE).withHardness(0.4F)
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN);
     public static final Block<BlockLogicSlab> SLAB_BRICK_NETHERRACK = register("slab.brick.netherrack", "minecraft:block/slab_brick_netherrack", 807, (BlockLogicSupplier<BlockLogicSlab>)b -> new BlockLogicSlab(b, Blocks.BRICK_NETHERRACK))
         .withSound(BlockSounds.STONE).withHardness(0.4F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
@@ -1141,7 +1141,7 @@ public final class Blocks {
     public static final Block<BlockLogicLamp> LAMP_INVERTED_ACTIVE = register("lamp.inverted.active", "minecraft:block/lamp_inverted_active", 853, (BlockLogicSupplier<BlockLogicLamp>)b -> new BlockLogicLamp(b, true, true))
         .withSound(BlockSounds.GLASS).withLightEmission(0.9375F).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
         .setBlockItem(ItemBlockLamp::new)
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+        .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final Block<?> LANTERN_FIREFLY_GREEN = register("lantern.firefly.green", "minecraft:block/lantern_firefly_green", 870,
         (b) -> new BlockLogicLanternFirefly(b, MobFireflyCluster.FireflyColor.GREEN, () -> Items.LANTERN_FIREFLY_GREEN))
@@ -1274,7 +1274,6 @@ public final class Blocks {
         .withSound(BlockSounds.STONE).withHardness(1.5F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
 
-
     public static <T extends BlockLogic> Block<T> register(String key, String namespaceId, int id, BlockLogicSupplier<T> logicSupplier) {
         Block<T> container = new Block<>(id, key, namespaceId, logicSupplier);
 
diff --git a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRule.java b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRule.java
index 62530693d..bcae8c7bd 100644
--- a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRule.java
+++ b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRule.java
@@ -1,31 +1,32 @@
 package net.minecraft.core.data.gamerule;
 
 import com.mojang.nbt.tags.CompoundTag;
+import org.jetbrains.annotations.NotNull;
 
 public abstract class GameRule<T>
 {
-    private final String key;
+    private final @NotNull String key;
     private final T defaultValue;
 
-    public GameRule(String key, T defaultValue)
+    public GameRule(@NotNull final String key, final T defaultValue)
     {
         this.key = key;
         this.defaultValue = defaultValue;
     }
 
-    public String getKey()
+    public @NotNull String getKey()
     {
-        return key;
+        return this.key;
     }
 
     public T getDefaultValue()
     {
-        return defaultValue;
+        return this.defaultValue;
     }
 
-    public abstract void writeToNBT(CompoundTag tag, T value);
+    public abstract void writeToNBT(@NotNull CompoundTag tag, T value);
 
-    public abstract T readFromNBT(CompoundTag tag);
+    public abstract T readFromNBT(@NotNull CompoundTag tag);
 
-    public abstract T parseFromString(String string);
+    public abstract T parseFromString(@NotNull String string);
 }
diff --git a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleBoolean.java b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleBoolean.java
index dc581317d..1d26b64ce 100644
--- a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleBoolean.java
+++ b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleBoolean.java
@@ -3,6 +3,8 @@ package net.minecraft.core.data.gamerule;
 import com.mojang.nbt.tags.ByteTag;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.Tag;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class GameRuleBoolean
     extends GameRule<Boolean>
@@ -12,7 +14,7 @@ public class GameRuleBoolean
     }
 
     @Override
-    public void writeToNBT(CompoundTag tag, Boolean value)
+    public void writeToNBT(@NotNull CompoundTag tag, Boolean value)
     {
         ByteTag ruleTag = new ByteTag();
         ruleTag.setValue((byte)(value ? 1 : 0));
@@ -20,7 +22,7 @@ public class GameRuleBoolean
     }
 
     @Override
-    public Boolean readFromNBT(CompoundTag tag)
+    public Boolean readFromNBT(@NotNull CompoundTag tag)
     {
         Tag<?> ruleTag = tag.getTag(getKey());
         if (ruleTag instanceof ByteTag)
@@ -33,7 +35,7 @@ public class GameRuleBoolean
     }
 
     @Override
-    public Boolean parseFromString(String string)
+    public Boolean parseFromString(@NotNull String string)
     {
         if (string.equalsIgnoreCase("true")) return true;
         if (string.equalsIgnoreCase("false")) return false;
@@ -44,7 +46,7 @@ public class GameRuleBoolean
         }
         catch (NumberFormatException e)
         {
-            return null;
+            return getDefaultValue();
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleInteger.java b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleInteger.java
new file mode 100644
index 000000000..23ef1ac6a
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRuleInteger.java
@@ -0,0 +1,41 @@
+package net.minecraft.core.data.gamerule;
+
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.IntTag;
+import com.mojang.nbt.tags.Tag;
+import org.jetbrains.annotations.NotNull;
+
+public class GameRuleInteger extends GameRule<Integer> {
+    public GameRuleInteger(final String key, final Integer defaultValue) {
+        super(key, defaultValue);
+    }
+
+    @Override
+    public void writeToNBT(final @NotNull CompoundTag tag, final Integer value) {
+        final IntTag ruleTag = new IntTag(value);
+        tag.put(getKey(), ruleTag);
+    }
+
+    @Override
+    public Integer readFromNBT(final @NotNull CompoundTag tag) {
+        Tag<?> ruleTag = tag.getTag(getKey());
+        if (ruleTag instanceof IntTag)
+        {
+            return ((IntTag) ruleTag).getValue();
+        }
+
+        return getDefaultValue();
+    }
+
+    @Override
+    public Integer parseFromString(final @NotNull String string) {
+        try
+        {
+            return Integer.parseInt(string);
+        }
+        catch (NumberFormatException e)
+        {
+            return getDefaultValue();
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRules.java b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRules.java
index 8c0210fae..6a79d2d0a 100644
--- a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRules.java
+++ b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRules.java
@@ -16,6 +16,7 @@ public abstract class GameRules
     public static GameRuleBoolean DO_WEATHER_CYCLE = register(new GameRuleBoolean("doWeatherCycle", true));
     public static GameRuleBoolean DO_FIRE_SPREAD = register(new GameRuleBoolean("doFireSpread", true));
     public static GameRuleBoolean INSTANT_HEALING = register(new GameRuleBoolean("instantHealing", false));
+    public static GameRuleInteger RANDOM_TICK_SPEED = register(new GameRuleInteger("randomTickSpeed", 4));
 
     public static <T extends GameRule<?>> T register(T gameRule)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
index d30aad4c1..321ff8109 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
@@ -8,6 +8,8 @@ import com.google.gson.JsonParseException;
 import com.google.gson.JsonSerializationContext;
 import com.google.gson.JsonSerializer;
 import com.mojang.logging.LogUtils;
+import com.mojang.nbt.NbtIo;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
@@ -59,13 +61,17 @@ public class ItemStackJsonAdapter implements JsonDeserializer<ItemStack>, JsonSe
         }
         int amount = 1;
         int meta = 0;
+        CompoundTag tag = null;
         if (obj.has("amount")) {
             amount = obj.get("amount").getAsInt();
         }
         if (obj.has("meta")) {
             meta = obj.get("meta").getAsInt();
         }
-        return new ItemStack(item, amount, meta);
+        if (obj.has("tag")) {
+            tag = NbtIo.fromJson(obj.get("tag"));
+        }
+        return new ItemStack(item, amount, meta, tag);
     }
 
     @Override
@@ -79,6 +85,9 @@ public class ItemStackJsonAdapter implements JsonDeserializer<ItemStack>, JsonSe
         if (verbose || src.getMetadata() != 0) {
             obj.addProperty("meta",src.getMetadata());
         }
+        if (verbose || !src.getData().getValue().isEmpty()) {
+            obj.add("tag", NbtIo.toJson(src.getData()));
+        }
         return obj;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShaped.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShaped.java
index 1138fbddf..2a9c91fb3 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShaped.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShaped.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.data.registry.recipe.entry;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.HasJsonAdapter;
@@ -188,7 +189,7 @@ public class RecipeEntryCraftingShaped extends RecipeEntryCrafting<RecipeSymbol[
 
     @Override
     public ItemStack getCraftingResult(ContainerCrafting containerCrafting) {
-        return new ItemStack(getOutput().itemID, getOutput().stackSize, getOutput().getMetadata());
+        return getOutput().copy();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/AgedMob.java b/game/core/src/main/java/net/minecraft/core/entity/AgedMob.java
new file mode 100644
index 000000000..1609ca2c5
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/entity/AgedMob.java
@@ -0,0 +1,7 @@
+package net.minecraft.core.entity;
+
+import org.jetbrains.annotations.NotNull;
+
+public interface AgedMob {
+    @NotNull MobAge getMobAge();
+}
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 342f01bd1..45b628142 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -185,13 +185,13 @@ public abstract class Entity
         return false;
     }
 
-    protected void setSize(float width, float height)
+    protected final void setSize(float width, float height)
     {
         this.bbWidth = width;
         this.bbHeight = height;
     }
 
-    public void setRot(float yRot, float xRot)
+    public final void setRot(float yRot, float xRot)
     {
         this.yRot = yRot % 360F;
         this.xRot = xRot % 360F;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 7ac1d3fdd..d58874bc8 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -153,7 +153,7 @@ public abstract class Mob extends Entity
         this.noAI = SPAWN_NO_AI;
     }
 
-    protected void setTextureIdentifier(final  @NotNull String namespace, final @NotNull String id) {
+    protected final void setTextureIdentifier(final  @NotNull String namespace, final @NotNull String id) {
         this.textureIdentifier = new NamespaceID(namespace, id);
         this.basePath = String.format("/assets/%s/textures/entity/%s/", this.textureIdentifier.namespace, this.textureIdentifier.value);
         this.defaultTexture = this.basePath + "0.png";
@@ -252,23 +252,32 @@ public abstract class Mob extends Entity
         onLabelled();
     }
 
+    protected float getPitchModifier() {
+        if (this instanceof AgedMob) {
+            final float scale = ((AgedMob) this).getMobAge().getAgeScale();
+            return 0.8f - (scale * 0.8f);
+        } else {
+            return 0.0f;
+        }
+    }
+
     public void playLivingSound()
     {
         String s = getLivingSound();
         if(s != null && !world.isClientSide)
         {
-            world.playSoundAtEntity(null, this, s, getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
+            world.playSoundAtEntity(null, this, s, getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F + getPitchModifier());
         }
     }
     
     public void playHurtSound()
     {
-        world.playSoundAtEntity(null, this, getHurtSound(), getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
+        world.playSoundAtEntity(null, this, getHurtSound(), getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F + getPitchModifier());
     }
     
     public void playDeathSound()
     {
-        world.playSoundAtEntity(null, this, getDeathSound(), getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
+        world.playSoundAtEntity(null, this, getDeathSound(), getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F + getPitchModifier());
     }
 
     @Override
